Index: /trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh
===================================================================
--- /trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 64172)
+++ /trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 64173)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2014 Oracle Corporation
+; Copyright (C) 2006-2016 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -36,7 +36,9 @@
 LangString VBOX_COMPONENT_MAIN ${LANG_ENGLISH}                      "VirtualBox Guest Additions"
 LangString VBOX_COMPONENT_MAIN_DESC ${LANG_ENGLISH}                 "VirtualBox Guest Additions main files"
+
 LangString VBOX_COMPONENT_AUTOLOGON ${LANG_ENGLISH}                 "Auto-Logon support"
 LangString VBOX_COMPONENT_AUTOLOGON_DESC ${LANG_ENGLISH}            "Enables automatic log-on support for guests"
 LangString VBOX_COMPONENT_AUTOLOGON_WARN_3RDPARTY ${LANG_ENGLISH}   "Another installed application already provides automatic log-on support.$\r$\nIf you replace this support with that provided by VirtualBox the system could become unstable.$\r$\nAre you sure you wish to proceed?"
+
 LangString VBOX_COMPONENT_D3D  ${LANG_ENGLISH}                      "Direct3D Support (Experimental)"
 LangString VBOX_COMPONENT_D3D_DESC  ${LANG_ENGLISH}                 "Enables Direct3D support for guests (Experimental)"
@@ -47,4 +49,7 @@
 LangString VBOX_COMPONENT_D3D_INVALID ${LANG_ENGLISH}               "The setup detected a corrupt/invalid DirectX installation.$\r$\n$\r$\nIn order to get Direct3D support working, consulting the VirtualBox manual is highly recommended.$\r$\n$\r$\nContinue anyway?"
 LangString VBOX_COMPONENT_D3D_INVALID_MANUAL ${LANG_ENGLISH}        "Shall the VirtualBox manual be displayed now to look for a solution?"
+
+LangString VBOX_COMPONENT_STARTMENU ${LANG_ENGLISH}                 "Start menu entries"
+LangString VBOX_COMPONENT_STARTMENU_DESC ${LANG_ENGLISH}            "Creates entries in the start menu"
 
 LangString VBOX_WFP_WARN_REPLACE ${LANG_ENGLISH}                    "In order to make ${PRODUCT_NAME} work correctly some system files have been replaced.$\r$\nIf the Windows File Protection service offers to restore the original files you should cancel the request to retain the newly installed functionality."
Index: /trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh
===================================================================
--- /trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 64172)
+++ /trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 64173)
@@ -36,7 +36,9 @@
 LangString VBOX_COMPONENT_MAIN ${LANG_FRENCH}                       "Additions invité VirtualBox"
 LangString VBOX_COMPONENT_MAIN_DESC ${LANG_FRENCH}                  "Fichiers prinipaux des Additions invité VirtualBox"
+
 LangString VBOX_COMPONENT_AUTOLOGON ${LANG_FRENCH}                  "Support identification automatique"
 LangString VBOX_COMPONENT_AUTOLOGON_DESC ${LANG_FRENCH}             "Active l'identification automatique dans l'invité"
 LangString VBOX_COMPONENT_AUTOLOGON_WARN_3RDPARTY ${LANG_FRENCH}    "Un composant permettant l'identification automatique est déjà installé.$\r$\nSi vous le remplacé avec le composant issue de VirtualBox, cela pourrait déstabiliser le système.$\r$\nDésirez-vous cependant continuer?"
+
 LangString VBOX_COMPONENT_D3D  ${LANG_FRENCH}                       "Support Direct3D pour invités (experimental)"
 LangString VBOX_COMPONENT_D3D_DESC  ${LANG_FRENCH}                  "Active le support Direct3D pour invités (experimental)"
@@ -47,4 +49,7 @@
 LangString VBOX_COMPONENT_D3D_INVALID ${LANG_FRENCH}                "Le programme d'installation a détecté une installation DirectX corrompue ou invalide.$\r$\n$\r$\nAfin d'assurer le bon fonctionnement du support DirectX, nous conseillons de réinstaller le moteur d'exécution DirectX.$\r$\n$\r$\nDésirez-vous cependant continuer?"
 LangString VBOX_COMPONENT_D3D_INVALID_MANUAL ${LANG_FRENCH}         "Voulez-vous voir le manuel d'utilisateur VirtualBox pour chercher une solution?"
+
+LangString VBOX_COMPONENT_STARTMENU ${LANG_FRENCH}                  "Start menu entries"
+LangString VBOX_COMPONENT_STARTMENU_DESC ${LANG_FRENCH}             "Creates entries in the start menu"
 
 LangString VBOX_WFP_WARN_REPLACE ${LANG_FRENCH}                     "Le programme d'installation vient de remplacer certains fichiers systèmes afin de faire fonctionner correctement ${PRODUCT_NAME}.$\r$\nPour le cas qu'un avertissement de la Protection de fichiers Windows apparaisse, veuiller l'annuler sans restaurer les fichiers originaux!"
Index: /trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh
===================================================================
--- /trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 64172)
+++ /trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 64173)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2014 Oracle Corporation
+; Copyright (C) 2006-2016 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -36,7 +36,9 @@
 LangString VBOX_COMPONENT_MAIN ${LANG_GERMAN}                       "VirtualBox Guest Additions"
 LangString VBOX_COMPONENT_MAIN_DESC ${LANG_GERMAN}                  "Hauptkomponenten der VirtualBox Guest Additions"
+
 LangString VBOX_COMPONENT_AUTOLOGON ${LANG_GERMAN}                  "Unterstützung für automatisches Anmelden"
 LangString VBOX_COMPONENT_AUTOLOGON_DESC ${LANG_GERMAN}             "Ermöglicht automatisches Anmelden von Benutzern"
 LangString VBOX_COMPONENT_AUTOLOGON_WARN_3RDPARTY ${LANG_GERMAN}    "Es ist bereits eine Komponente für das automatische Anmelden installiert.$\r$\nFalls Sie diese Komponente nun mit der von VirtualBox ersetzen, könnte das System instabil werden.$\r$\nDennoch installieren?"
+
 LangString VBOX_COMPONENT_D3D  ${LANG_GERMAN}                       "Direct3D-Unterstützung (Experimentell)"
 LangString VBOX_COMPONENT_D3D_DESC  ${LANG_GERMAN}                  "Ermöglicht Direct3D-Unterstützung für Gäste (Experimentell)"
@@ -47,4 +49,7 @@
 LangString VBOX_COMPONENT_D3D_INVALID ${LANG_GERMAN}                "Das Setup hat eine ungültige/beschädigte DirectX-Installation festgestellt.$\r$\n$\r$\nUm die Direct3D-Unterstützung installieren zu können wird empfohlen, zuerst das VirtualBox Benutzerhandbuch zu konsultieren.$\r$\n$\r$\nMit der Installation jetzt trotzdem fortfahren?"
 LangString VBOX_COMPONENT_D3D_INVALID_MANUAL ${LANG_GERMAN}         "Soll nun das VirtualBox-Handbuch angezeigt werden um nach einer Lösung zu suchen?"
+
+LangString VBOX_COMPONENT_STARTMENU ${LANG_GERMAN}                  "Startmenü-Einträge"
+LangString VBOX_COMPONENT_STARTMENU_DESC ${LANG_GERMAN}             "Erstellt Einträge im Startmenü"
 
 LangString VBOX_WFP_WARN_REPLACE ${LANG_GERMAN}                     "Das Setup hat gerade Systemdateien ersetzt um die ${PRODUCT_NAME} korrekt installieren zu können.$\r$\nFalls nun ein Warn-Dialog des Windows-Dateischutzes erscheint, diesen bitte abbrechen und die Dateien nicht wiederherstellen lassen!"
Index: /trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi
===================================================================
--- /trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi	(revision 64172)
+++ /trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi	(revision 64173)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2012-2014 Oracle Corporation
+; Copyright (C) 2012-2016 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -234,4 +234,5 @@
 Var g_bNoGuestDrv                       ; Cmd line: Do not install the VBoxGuest driver
 Var g_bNoMouseDrv                       ; Cmd line: Do not install the VBoxMouse driver
+Var g_bNoStartMenuEntries               ; Cmd line: Do not create start menu entries
 Var g_bWithAutoLogon                    ; Cmd line: Install VBoxGINA / VBoxCredProv for auto logon support
 Var g_bWithD3D                          ; Cmd line: Install Direct3D support
@@ -343,4 +344,8 @@
       ${Case} '/no_mousedrv' ; Not officially documented
         StrCpy $g_bNoMouseDrv "true"
+        ${Break}
+
+      ${Case} '/no_startmenuentries' ; Not officially documented
+        StrCpy $g_bNoStartMenuEntries "true"
         ${Break}
 
@@ -889,9 +894,10 @@
   ;Assign language strings to sections
   !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
-    !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} $(VBOX_COMPONENT_MAIN_DESC)
-    !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} $(VBOX_COMPONENT_AUTOLOGON_DESC)
-  !if $%VBOX_WITH_CROGL% == "1"
-    !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} $(VBOX_COMPONENT_D3D_DESC)
-  !endif
+    !insertmacro MUI_DESCRIPTION_TEXT   ${SEC01} $(VBOX_COMPONENT_MAIN_DESC)
+    !insertmacro MUI_DESCRIPTION_TEXT   ${SEC02} $(VBOX_COMPONENT_AUTOLOGON_DESC)
+    !if $%VBOX_WITH_CROGL% == "1"
+      !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} $(VBOX_COMPONENT_D3D_DESC)
+    !endif
+    !insertmacro MUI_DESCRIPTION_TEXT   ${SEC04} $(VBOX_COMPONENT_STARTMENU_DESC)
   !insertmacro MUI_FUNCTION_DESCRIPTION_END
 !endif ; USE_MUI
@@ -903,4 +909,6 @@
 SectionEnd
 
+; Start menu entries. Enabled by default and can be disabled by the user.
+Section /o $(VBOX_COMPONENT_STARTMENU) SEC04
 Section -StartMenu
 
@@ -1088,4 +1096,5 @@
   StrCpy $g_bNoGuestDrv "false"
   StrCpy $g_bNoMouseDrv "false"
+  StrCpy $g_bStartMenuEntries "false"
   StrCpy $g_bWithAutoLogon "false"
   StrCpy $g_bWithD3D "false"
@@ -1177,8 +1186,14 @@
   Call CheckForInstalledComponents
 
-  ; Set section bits
+  ;
+  ; Section 02
+  ;
   ${If} $g_bWithAutoLogon == "true" ; Auto-logon support
     !insertmacro SelectSection ${SEC02}
   ${EndIf}
+
+  ;
+  ; Section 03
+  ;
 !if $%VBOX_WITH_CROGL% == "1"
   ${If} $g_bWithD3D == "true" ; D3D support
@@ -1198,4 +1213,11 @@
   ${EndIf}
 
+  ;
+  ; Section 04
+  ;
+  ${If} $g_bNoStartMenuEntries == "false" ; Start menu entries
+    !insertmacro SelectSection ${SEC04}
+  ${EndIf}
+
 !ifdef USE_MUI
   ; Display language selection dialog (will be hidden in silent mode!)